"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const sdk_1 = __importStar(require("@searchkit/sdk"));
const common_1 = require("../common");
const Configuration_1 = require("../search/Configuration");
function buildConfiguration({ host, index, apiKey, searchFields, resultFields }) {
    const { hitFields, highlightFields } = (0, Configuration_1.getResultFields)(resultFields);
    const queryFields = (0, Configuration_1.getQueryFields)(searchFields);
    const searchkitConfiguration = {
        host: host,
        index: index,
        connectionOptions: {
            apiKey: apiKey
        },
        query: new sdk_1.MultiMatchQuery({
            fields: queryFields
        }),
        hits: {
            fields: hitFields,
            highlightedFields: highlightFields
        }
    };
    return searchkitConfiguration;
}
function handler(state, queryConfig, host, index, apiKey) {
    return __awaiter(this, void 0, void 0, function* () {
        const searchkitConfiguration = buildConfiguration({
            host,
            index,
            apiKey,
            searchFields: queryConfig.results.search_fields,
            resultFields: queryConfig.results.result_fields
        });
        const response = yield (0, sdk_1.default)(searchkitConfiguration)
            .query(state.searchTerm)
            .execute({
            facets: false,
            hits: {
                from: 0,
                size: queryConfig.results.resultsPerPage || 5,
                includeRawHit: true
            }
        });
        return response.hits.items.map(common_1.fieldResponseMapper);
    });
}
exports.default = handler;
